/*
 * DispatcherTest.java
 * JUnit based test
 *
 * Created on Streda, 2007, november 21, 19:39
 */
package cz.muni.fi.pb162.traffic.turnstiles;

import cz.muni.fi.pb162.traffic.common.World;
import junit.framework.TestCase;

/**
 *
 * @author misko
 */
public class DispatcherTest extends TestCase {

    World world = new World();

    public DispatcherTest(String testName) {
        super(testName);
    }

    protected void setUp() throws Exception {
        world.createWorld();
    }

    protected void tearDown() throws Exception {
        world.destroyWorld();
    }

    /**
     * Tests of dispatch method, of class cz.muni.fi.pb162.traffic.turnstiles.Dispatcher.
     */
    public void testDispatchCeska2Grohova() {
        Dispatcher dispatcher = world.getDispatcher();
    }

    public void testDispatchCeska2BotanickaAndHrncirska2Klusackova() {
        Dispatcher dispatcher = world.getDispatcher();
        assertTrue(dispatcher.dispatch("0041", 1, true));
        assertTrue(dispatcher.dispatch("a78f", 1, false));
        assertEquals(1, world.getTickets().getTicket(1).getCredit());
        assertTrue(dispatcher.dispatch("1747", 1, true));
        assertTrue(dispatcher.dispatch("1231", 1, false));
        assertEquals(-3, world.getTickets().getTicket(1).getCredit());
        assertFalse(dispatcher.dispatch("0101", 1, true));
    }

    public void testDispatchRybkova2Hrncirska2Hlavak2Klusackova2() {

        Dispatcher dispatcher = world.getDispatcher();
        assertTrue(dispatcher.dispatch("7z7z", 0, true));
        assertTrue(dispatcher.dispatch("1747", 0, false));
        assertEquals(11, world.getTickets().getTicket(0).getCredit());
        assertTrue(dispatcher.dispatch("1747", 0, true));
        assertTrue(dispatcher.dispatch("1314", 0, false));
        assertEquals(6, world.getTickets().getTicket(0).getCredit());
        assertTrue(dispatcher.dispatch("1314", 0, true));
        assertTrue(dispatcher.dispatch("0101", 0, false));
        assertEquals(2, world.getTickets().getTicket(0).getCredit());
        assertTrue(dispatcher.dispatch("0101", 0, true));
        assertTrue(dispatcher.dispatch("1747", 0, false));
        assertEquals(-1, world.getTickets().getTicket(0).getCredit());
        assertFalse(dispatcher.dispatch("1231", 0, true));
    }

    public void testDispatchMixed() {
        Dispatcher dispatcher = world.getDispatcher();

        assertTrue(dispatcher.dispatch("7z7z", 0, true));
        assertTrue(dispatcher.dispatch("0041", 1, true));
        assertTrue(dispatcher.dispatch("1747", 0, false));
        assertEquals(11, world.getTickets().getTicket(0).getCredit());
        assertTrue(dispatcher.dispatch("a78f", 1, false));
        assertTrue(dispatcher.dispatch("0041", 2, true));
        assertTrue(dispatcher.dispatch("1747", 0, true));
        assertTrue(dispatcher.dispatch("1314", 0, false));
        assertEquals(1, world.getTickets().getTicket(1).getCredit());
        assertEquals(6, world.getTickets().getTicket(0).getCredit());
        assertTrue(dispatcher.dispatch("0101", 2, false));
        assertTrue(dispatcher.dispatch("1314", 0, true));
        assertTrue(dispatcher.dispatch("0101", 0, false));
        assertEquals(2, world.getTickets().getTicket(0).getCredit());
        assertTrue(dispatcher.dispatch("1747", 1, true));
        assertTrue(dispatcher.dispatch("0101", 0, true));
        assertTrue(dispatcher.dispatch("1231", 1, false));
        assertTrue(dispatcher.dispatch("1747", 0, false));
        assertEquals(-3, world.getTickets().getTicket(1).getCredit());
        assertEquals(-1, world.getTickets().getTicket(0).getCredit());
        assertFalse(dispatcher.dispatch("1231", 0, true));
        assertFalse(dispatcher.dispatch("0101", 1, true));
        assertEquals(299, world.getTickets().getTicket(2).getCredit());
        
    }

    public void testCreditBuying() {
        Dispatcher dispatcher = world.getDispatcher();

        assertTrue(dispatcher.dispatch("0041", 1, true));
        assertTrue(dispatcher.dispatch("a78f", 1, false));
        assertEquals(1, world.getTickets().getTicket(1).getCredit());
        assertTrue(dispatcher.dispatch("1747", 1, true));
        assertTrue(dispatcher.dispatch("1231", 1, false));
        assertEquals(-3, world.getTickets().getTicket(1).getCredit());
        assertFalse(dispatcher.dispatch("0101", 1, true));

        world.getTickets().getTicket(1).addCredit(5);
        assertEquals(2, world.getTickets().getTicket(1).getCredit());
        assertTrue(dispatcher.dispatch("1314", 1, true));
        assertTrue(dispatcher.dispatch("54kc", 1, false));
        assertEquals(0, world.getTickets().getTicket(1).getCredit());
        assertFalse(dispatcher.dispatch("a78f", 1, true));


    }
}
